var scroller = null;
var Movies = new Array();
var BaseURL = "http://movie.goo.ne.jp";
var Preferences = { image:true, reload:true };

function init() {
    setTimeout( _startTimer, 0 );
    //_startTimer();
    try {
        scroller = new Scroller( document.getElementById( "tableContainer" ), document.getElementById( "rankTable" ), document.getElementById( "scrollTrack" ), document.getElementById( "scrollThumb" ) );
    } catch ( e ) {
    }

    for ( var i = 0; i < 12; i++ ) {
        ( new Image() ).src = "Images/Wait" + i + ".png";
    }

    if ( window.widget ) {
        var flag_image = widget.preferenceForKey( "showImage" );
        var flag_reload = widget.preferenceForKey( "autoReload" );
        if ( flag_image != undefined ) {
            Preferences.image = flag_image;
        }
        if ( flag_reload != undefined ) {
            Preferences.reload  = flag_reload;
        }
        var b0 = document.getElementById( "reloadCheck" );
        if ( Preferences.reload ) {
            b0.setAttribute( "checked" );
        } else {
            b0.removeAttribute( "checked" );
        }
        
        var b1 = document.getElementById( "imageCheck" );
        if ( Preferences.image ) {
            b1.setAttribute( "checked" );
        } else {
            b1.removeAttribute( "checked" );
        }
    }


    createGenericButton( document.getElementById( "done" ), "Done", flipToFront );

    setReloadButton();
    _startReloadMonitoring();
    //parseHTML( contents );
    setTimeout( _startLoading, 100 );
}

var _loading = false;
function setReloadButton() {
    var div = document.getElementById( "button" );
    div.addEventListener( "mousedown", _reloadButtonPushed );
}
function _reloadButtonPushed( event ) {
    var div = document.getElementById( "button" );
    if ( div ) {
        _setReloadButtonIcon( true );
//         if ( _loading ) {
//             div.style.background = "url(Images/StopButton2.png)";
//         } else {
//             div.style.background = "url(Images/ReloadButton2.png)";
//         }
        div.addEventListener( "mouseup", _reloadButtonAction, true );
        div.addEventListener( "mouseout", _reloadButtonCancel, true );
    }
}

function _setReloadButtonIcon( pushed ) {
    var div = document.getElementById( "button" );
    if ( div ) {
        var bn = 1;
        if ( pushed ) bn = 2;
        if ( _loading ) {
            div.style.background = "url(Images/StopButton" + bn + ".png)";
        } else {
            div.style.background = "url(Images/ReloadButton" + bn + ".png)";
        }
    }
}

function _reloadButtonCancel( event ) {
    var div = document.getElementById( "button" );
    if ( div ) {
        _setReloadButtonIcon( false );
//         if ( _loading ) {
//             div.style.background = "url(Images/StopButton1.png)";
//         } else {
//             div.style.background = "url(Images/ReloadButton1.png)";
//         }
        div.removeEventListener( "mouseout", _reloadButtonAction );
        div.removeEventListener( "mouseup", _reloadButtonCancel );
    }    
}

function _reloadButtonAction( event ) {
    _reloadButtonCancel( event );
    if ( _loading ) {
        SiteLoader.prototype.abortAll();
    } else {
        setTimeout( _startTimer, 0 );
        setTimeout( _startLoading, 100 );
    }
    _loading = !_loading;
}


function flipToBack( event ) {
    var front = document.getElementById( "front" );
    var back =  document.getElementById( "behind" );
    if ( window.widget ) widget.prepareForTransition( "ToBack" );
    back.style.display = "block";
    front.style.display = "none";
    if ( window.widget ) setTimeout( "widget.performTransition();", 0 );
}

function flipToFront( event ) {
    var front = document.getElementById( "front" );
    var back =  document.getElementById( "behind" );
    if ( window.widget ) widget.prepareForTransition( "ToFront" );
    back.style.display = "none";
    front.style.display = "block";
    var b0 = document.getElementById( "reloadCheck" );
    var b1 = document.getElementById( "imageCheck" );
    Preferences.reload = ( b0.value == "on" );
    Preferences.image  = ( b1.value == "on" );
    //debug( "value " + b1.value + ", checked " + b1.getAttribute( "checked" ) );
    if ( window.widget ) {
        widget.setPreferenceForKey( Preferences.image, "showImage" );
        widget.setPreferenceForKey( Preferences.reload, "autoReload" );
        setTimeout( "widget.performTransition();", 0 );
    }
}

var reloadTimer = null;
var reloadCount = 0;
var reloadHours = 6;
function _startReloadMonitoring() {
    if ( reloadTimer ) return;
    reloadTimer = setInterval( _tickReloadMonitoring, 1000 * 60 * 60 * reloadHours );
}

function _tickReloadMonitoring() {
    if ( Preferences.reload == false ) return;
    reloadCount ++;
    if ( reloadCount >= reloadHours ) {
        reloadCount = 0;
        setTimeout( _startTimer, 0 );
        setTimeout( _startLoading, 100 );
    }
}

function _startLoading() {
    var url = BaseURL + "/ranking/boxoffice/index.html";
    var parser = parseHTML;
    var loader = new SiteLoader( url, parser, _stopTimerIfPossible );
    _loading = true;
    _setReloadButtonIcon( false );
    loader.start();
}

function _stopTimerIfPossible() {
    if ( SiteLoader.prototype.existsRunningProcess() == false ) {
        _stopTimer();
        _loading = false;
        var div = document.getElementById( "button" );
        if ( div ) {
            div.style.background = "url(Images/ReloadButton1.png)";
        }
    }
}

// wait rolly
var waitTimer = null;
var waitCount = 0;

function _startTimer() {
    if ( waitTimer ) _stopTimer();
    document.getElementById( "wait" ).style.display = "block";
    waitTimer = setInterval( _tickTimer, 66 );
    _tickTimer();
}
function _stopTimer() {
    if ( waitTimer ) {
        clearInterval( waitTimer );
        waitTimer = null;
        document.getElementById( "wait" ).style.display = "none";
    }
}
function _tickTimer() {
    if ( waitCount >= 12 ) waitCount = 0;
    document.getElementById( "wait" ).src = "Images/Wait" + waitCount + ".png";
    waitCount++;
}


function MovieInformation( rowelem ) {
    var el_title = getElementAt( rowelem, "TD,3" );
    var children = el_title.childNodes;
    var reg_id = new RegExp( "/contents/movies/(.*)/index.html" );
    this.imageSrc = null;
    this.link = null;
    this.title = null;
    this.id = null;
    this.available = false;
    for ( var i = 0; i < children.length; i++ ) {
        var child = children.item( i );
        if ( child.nodeType != 1 ) continue;
        //debug( child.tagName );
        if ( child.tagName == "A" ) {
            if ( child.firstChild.nodeType == 1 && child.firstChild.tagName.toLowerCase() == "img" ) {
                this.imageSrc = BaseURL + child.firstChild.getAttribute( "src" );
                //debug( "imgsrc = " + this.imageSrc );
            } else {
                this.link  = BaseURL + child.getAttribute( "href" );
                this.title = getInsideTexts( child );
                var m = reg_id.exec( this.link );
                if ( m ) {
                    this.id = m[ 1 ];
                } else {
                    this.id = null;
                }
            }
            //break;
        }
    }
    //     var text = getInsideTexts( rowelem, "," );
    //     debug( text );
    if ( this.link != null && this.title != null && this.id != null ) {
        this.available = true;
    }
    this.photoGallery = false;
    //this.imageContainer = null;
	
    this.toString = function() {
        if ( this.available ) {
            var output = this.id + ":" + this.title + ":" + this.imageSrc;
            return output;
        } else {
            return "invalid object";
        }
    }
    this.retrieveData = function() {
        if ( this.available == false || Preferences.image == false ) {
            _stopTimerIfPossible();
            return;
        }
        var loader = new SiteLoader( this.link, __loadIndividual, _stopTimerIfPossible, this );
        loader.start();
    }
	
    this.createRowElement = __MovieInformation__createRowElement;
    this.division = null;
    this.ranking = 1;
}
function _createAnchorText( text, link ) {
    var anchor = document.createElement( "a" );
    if ( window.widget ) { // widget version
        anchor.setAttribute( "onclick", "widget.openURL('" + link + "')" );
    } else { // HTML
        anchor.setAttribute( "href", link );
    }
    anchor.appendChild( document.createTextNode( text ) );
    return anchor;
}

function __MovieInformation__createRowElement( em ) {
    this.division = em;
    //debug( em.name );
    while ( em.lastChild ) {
        em.removeChild( em.lastChild );
    }
    var rank = document.createElement( "div" );
    rank.setAttribute( "class", "movie-rank" );
    rank.appendChild( document.createTextNode( this.ranking ) );
    em.appendChild( rank );

    var title = document.createElement( "div" );
    title.setAttribute( "class", "movie-title" );
    title.appendChild( document.createTextNode( this.title ) );
    em.appendChild( title );
    debug( this.title );

    var link = document.createElement( "div" );
    link.setAttribute( "class", "movie-link" );
    var url_theater = BaseURL + "/contents/movies/" + this.id + "/theater.html";
    link.appendChild( _createAnchorText( "上映情報", url_theater ) );
    var url_amazon = "http://www.amazon.co.jp/exec/obidos/external-search?mode=blended&tag=wobsofweewidg-22&keyword=" + this.title;
    link.appendChild( _createAnchorText( "関連商品", url_amazon ) );
    em.appendChild( link );
	
    var icon = document.createElement( "div" );
    icon.setAttribute( "class", "movie-icon" );
    //if ( this.imageSrc != null || Preferences.image == false ) {
    var anc = document.createElement( "a" );
    if ( window.widget ) {
        anc.setAttribute( "onclick", "widget.openURL('" + BaseURL + "/contents/movies/" + this.id + "/index.html');" );
    } else {
        anc.setAttribute( "href", BaseURL + "/contents/movies/" + this.id + "/index.html" );
    }
    var img = document.createElement( "img" );
    if ( Preferences.image == false || this.imageSrc == null ) {
        img.src = "Images/Screen.png";
    } else {
        img.src = this.imageSrc;
    }
    img.setAttribute( "style", "position:absolute;height:48px;width:64px;right:0px;top:0px;border:none;" );//"width:64px;height:48px;" );
    anc.appendChild( img );
    icon.appendChild( anc );
//    }
    em.appendChild( icon );
}

function __loadIndividual( text, movie ) {
    // photo gallery
    
    var reg_img = new RegExp( "<img src=\"([^\"]+)", "gi" );
    var id = movie.id;
    var m = reg_img.exec( text );
    var threshold = 0.4;
    if ( movie.photoGallery ) threshold = 0.2;
	
    // find images
    var sources = new Array();
    while ( m ) {
        var src = m[ 1 ];
        if ( src.indexOf( id ) >= 0 ) {
            sources.push( BaseURL + src );
        }
        m = reg_img.exec( text );
    }
    // select a random image
    if ( sources.length > 0 ) {
        movie.imageSrc = sources[ parseInt( Math.random() * sources.length ) ];
    }
	
    // load photo gallery if no images found
    if ( movie.imageSrc == null && movie.photoGallery == false ) {
        var reg_pg = new RegExp( '<a href="([^"]+)"><b>フォトギャラリー</b></a>' );
        var m_pg = reg_pg.exec( text );
        if ( m_pg ) {
            debug( m_pg );
            var url_gallery = movie.link.substring( 0, movie.link.lastIndexOf( "/" ) ) + "/" + m_pg[ 1 ];
            movie.photoGallery = true;
            debug( "LOAD AGAIN " + url_gallery );
            var loader = new SiteLoader( url_gallery, __loadIndividual, _stopTimerIfPossible, movie );
            loader.start();
            return;
        } else {
            debug( "no image for " + movie );
        }
    }

//	debug( "MOVIE -DIV : " + movie.division.name );
    if ( movie.division ) {
        movie.createRowElement( movie.division );
    } else {
        var div = document.getElementById( "catalogue" );
        var anchor = document.createElement( "a" );
        var keyword = movie.title;

        anchor.setAttribute( "href", "http://www.amazon.co.jp/exec/obidos/external-search?mode=blended&tag=wobsofweewidg-22&keyword=" + movie.title );
        var img = document.createElement( "img" );
        img.setAttribute( "style", "width:64px;height:48px;" );
        img.src = movie.imageSrc;
        anchor.appendChild( img );
        div.appendChild( anchor );
    }
    debug( "data of " + movie.toString() );
    _stopTimerIfPossible();
}

function parseHTML( text ) {
    var parser = new _HTMLParser();
    var doc = parser.parse( text );
    var children = doc.childNodes;
    var root = doc.firstChild;
    var table = getElementAt( root, "HTML/BODY/DIV/TABLE,6/TR/TD/TABLE,6/TR/TD,2/TABLE" );
    var children = table.childNodes;
    Movies = new Array();
    var ranking = 1;
    var table = document.getElementById( "rankTable" );
    while ( table.lastChild ) {
        table.removeChild( table.lastChild );
    }
    for ( var i = 1; i < children.length; i++ ) {
        var obj = new MovieInformation( children.item( i ) );
        if ( obj.available ) {
            obj.ranking = ranking;
            var elem_row = document.createElement( "div" );
            elem_row.name = "ROW #" + ranking;
            elem_row.setAttribute( "class", "movie" );
            obj.createRowElement( elem_row );
            table.appendChild( elem_row );
            Movies.push( obj );
            ranking ++;
            //            debug( obj );
        }
        //break;
    }

    var delayLoad = new Array();
    for ( var i = 0; i < Movies.length; i++ ) {
        if ( Movies[ i ].imageSrc == null ) {
            Movies[ i ].retrieveData();
        } else {
            delayLoad.push( Movies[ i ] );
        }
    }
    for ( var i = 0; i < delayLoad.length; i++ ) {
        delayLoad[ i ].retrieveData();
    }
    if ( scroller ) {
        scroller.refresh();
    }
    //     if ( table ) {
    //         outputDOMText( table, debug );
    //     } else {
    //         debug( "no elements " );
    //     }
    //     for ( var i = 0; i < children.length; i++ ) {
    //         debug( children.item( i ) );
    //     }
}

